# /home/andre/DISTRIB_SC/SC/V2/MYEX/cruiseControlA.sc.tcl
# Copyrights Charles ANDRE - I3S Lab - 1996
# Creation date: Fri May  2 21:23:07 GMT 1997
# owner: andre
# creation directory: /home/andre/DISTRIB_SC/SC/V2/EXAMPLES
# version: 2.02


global isVALUED
set isVALUED 1
global zoneDesc
global applName
set applName cruiseControl
global _seedName
set rootWn 0
global decls
buildItem DCO "" "" "{cruiseControl is an example of multilevel syncCharts.

This example makes use of preemption (both abortion and suspension). 
It also needs some external functions, whose implementation must be 
provided by the host language.

There exists an improved version of this example (see improvedCC).

cruiseControlA is an incompletly specified version of the cruiseControl SC.
When making code generation, the user is requested to provide declarations
for ig_ON and ig_OFF.


}"
buildItem DCO $rootWn "" "{This is the first level. You enter MotorON by ignition (ig_ON) and
you leave it by a strong abortion triggered by ig_OFF.

}"
# #### window cruiseControl: .root  -> 0  (begin)
buildW $rootWn "" 4 3 4 cruiseControl "4"
# node description

# separators
buildItem Z $rootWn 1 "{Z 0.0 0.0 2.0 2.0}"

buildItem F $rootWn 1 "145.0 130.0 130.0 115.0 0 \"\" \"\" cruiseControl \"0\" \"1\" \"0\" \"\""
buildItem C $rootWn 2 "152.0 65.0 \"1\" \"\" I"
buildItem S $rootWn 3 "152.0 113.0 15 \"2\" \"1 3\" N \"\" \"\" \"0\""
buildItem M $rootWn 4 "152.0 206.0 45.9999 25.0 0 \"3\" \"2\" N \"\" \"@MotorON\" \"4\" "

# edge description
buildItem E $rootWn 1 "I 2 3 {152.0 65.0 152.0 98.0} 1 \"\" \"\" \"\" \"0\" \"0\" \"\" "
buildItem E $rootWn 2 "S 3 4 {174.36 124.18 212.0 143.0 175.81 181.0} 1 \"ig_ON\" \"\" \"\" \"2\" \"0\" \"\" "
buildItem E $rootWn 3 "S 4 3 {121.009 173.794 101.0 153.0 140.197 122.257} 1 \"ig_OFF\" \"\" \"\" \"3\" \"0\" \"\" "

# label description (4)
buildItem L $rootWn 1 "ln 145.0 22 1 \"cruiseControl\" \"\""
buildItem L $rootWn 2 "wa 227.0 143.0 2 \"ig_ON\" \"\""
buildItem L $rootWn 3 "wa 86.0 142.0 3 \"ig_OFF\" \"\""
buildItem L $rootWn 4 "ln 154 210 4 \"@MotorON\" \"\""

# #### window .root   (end)
buildItem DCO $rootWn "4" "{Note the use of (local) signals for synchronization.
#controlled stands for the immediate suspension of macrostate normalGaz,
whenever the signal controlled is present.

}"
buildItem DIN $rootWn "4" "{setGear resetGear ON OFF}"
# #### window MotorON: .root.10  -> 0 4 (begin)
buildW $rootWn "4" 10 8 10 MotorON "8 9"
# node description

# separators
buildItem Z $rootWn 4.1 "{V 0.627027 6}"
buildItem Z $rootWn 4.1l "{Z 0.0 0.0 0.627027 2.0}"
buildItem Z $rootWn 4.1rr "{Z 1.23318 0.0 2.0 2.0}"
buildItem Z $rootWn 4.1r "{V 1.23318 7}"
buildItem Z $rootWn 4.1rl "{Z 0.627027 0.0 1.23318 2.0}"

buildItem F $rootWn 4.1 "324.0 200.0 309.0 185.0 14 \"controlled,OverDrive\" \"\" MotorON \"0\" \"1\" \"6\" \"\""
buildItem C $rootWn 4.2 "112 62 \"1\" \"\" I"
buildItem C $rootWn 4.3 "309 59 \"2\" \"\" I"
buildItem C $rootWn 4.4 "518 68 \"4\" \"\" I"
buildItem C $rootWn 4.5 "308 301 \"3\" \"\" I"
buildItem S $rootWn 4.6 "113 107 15 \"5\" \"1 6\" N \"\" \"\" \"0\""
buildItem S $rootWn 4.7 "112 232 15 \"6\" \"5\" N \"\" \"OverDrive\" \"4\""
buildItem M $rootWn 4.8 "308 157 50.0001 36.9999 0 \"\" \"2 3\" N \"\" \"@normalGaz\" \"7\" "
buildItem M $rootWn 4.9 "519 257 74.0001 44.0001 0 \"8\" \"7\" N \"\" \"@ActiveSC\" \"8\" "
buildItem S $rootWn 4.10 "517 132 15 \"7\" \"4 8\" N \"\" \"\" \"0\""

# edge description
buildItem E $rootWn 4.1 "I 2 6 {112.0 62.0 112.667 92.0037} 1 \"\" \"\" \"\" \"0\" \"0\" \"\" "
buildItem E $rootWn 4.2 "I 3 8 {309.0 59.0 308.378 120.0} 1 \"\" \"\" \"\" \"0\" \"0\" \"\" "
buildItem E $rootWn 4.3 "H 5 8 {308.0 301.0 308.0 204.0} 1 \"controlled\" \"\" \"\" \"5\" \"1\" \"\" "
buildItem E $rootWn 4.4 "I 4 10 {518.0 68.0 517.234 117.002} 1 \"\" \"\" \"\" \"0\" \"0\" \"\" "
buildItem E $rootWn 4.5 "S 6 7 {126.582 127.99 157.0 175.0 121.295 220.227} 1 \"setGear\" \"\" \"\" \"2\" \"0\" \"\" "
buildItem E $rootWn 4.6 "S 7 6 {92.453 216.415 38.0 173.0 101.739 116.909} 1 \"resetGear\" \"\" \"\" \"3\" \"0\" \"\" "
buildItem E $rootWn 4.7 "S 10 9 {538.063 145.467 578.0 171.0 549.186 213.0} 1 \"ON and OverDrive\" \"\" \"\" \"9\" \"0\" \"\" "
buildItem E $rootWn 4.8 "S 9 10 {487.694 204.407 469.0 173.0 505.594 141.742} 1 \"OFF or resetGear\" \"\" \"\" \"10\" \"0\" \"\" "

# label description (10)
buildItem L $rootWn 4.1 "ln 324.0 22 1 \"MotorON\" \"\""
buildItem L $rootWn 4.2 "wa 161 134 5 \"setGear\" \"\""
buildItem L $rootWn 4.3 "wa 54 206 6 \"resetGear\" \"\""
buildItem L $rootWn 4.4 "st 106 260 7 \"OverDrive\" \"\""
buildItem L $rootWn 4.5 "h 266 249 3 \"#controlled\" \"\""
buildItem L $rootWn 4.6 "ld 324.0 377 1 \"signal controlled,OverDrive\" \"\""
buildItem L $rootWn 4.7 "ln 308 159 8 \"@normalGaz\" \"\""
buildItem L $rootWn 4.8 "ln 521 261 9 \"@ActiveSC\" \"\""
buildItem L $rootWn 4.9 "wa 564 165 7 \"ON and OverDrive\" \"\""
buildItem L $rootWn 4.10 "wa 493 191 8 \"OFF or resetGear\" \"\""

# #### window .root.10   (end)
buildItem DFN $rootWn "4.8" "{A(integer):integer}"
buildItem DSE $rootWn "4.8" "{ACC:integer}"
buildItem DOU $rootWn "4.8" "{TVC:integer}"
# #### window normalGaz: .root.10.17  -> 0 4.8 (begin)
buildW $rootWn "4.8" 3 1 2 normalGaz ""
# node description

# separators
buildItem Z $rootWn 4.8.1 "{Z 0.0 0.0 2.0 2.0}"

buildItem F $rootWn 4.8.1 "96.0 93.0 81.0 78.0 0 \"\" \"\" normalGaz \"0\" \"1\" \"0\" \"\""
buildItem C $rootWn 4.8.2 "87.5 62.0 \"1\" \"\" I"
buildItem S $rootWn 4.8.3 "87.5 122.0 15 \"\" \"1\" N \"\" \"TVC(A(?ACC))\" \"2\""

# edge description
buildItem E $rootWn 4.8.1 "I 2 3 {87.5 62.0 87.5 107.0} 1 \"\" \"\" \"\" \"0\" \"0\" \"\" "

# label description (2)
buildItem L $rootWn 4.8.1 "ln 96.0 22 1 \"normalGaz\" \"\""
buildItem L $rootWn 4.8.2 "st 97.5 151.0 2 \"TVC(A(?ACC))\" \"\""

# #### window .root.10.17   (end)
buildItem DIN $rootWn "4.9" "{SET}"
# #### window ActiveSC: .root.10.19  -> 0 4.9 (begin)
buildW $rootWn "4.9" 4 3 4 ActiveSC "4"
# node description

# separators
buildItem Z $rootWn 4.9.1 "{Z 0.0 0.0 2.0 2.0}"

buildItem F $rootWn 4.9.1 "200 140 185 125 0 \"\" \"\" ActiveSC \"0\" \"1\" \"0\" \"\""
buildItem C $rootWn 4.9.2 "165 57 \"1\" \"\" I"
buildItem S $rootWn 4.9.3 "165 116 15 \"2\" \"1\" N \"\" \"\" \"0\""
buildItem M $rootWn 4.9.4 "161 205 63.0 35.0001 0 \"3\" \"2 3\" N \"\" \"@CSoperational\" \"4\" "

# edge description
buildItem E $rootWn 4.9.1 "I 2 3 {165.0 57.0 165.0 101.0} 1 \"\" \"\" \"\" \"0\" \"0\" \"\" "
buildItem E $rootWn 4.9.2 "W 3 4 {164.327 130.985 162.573 170.0} 1 \"SET\" \"\" \"\" \"2\" \"0\" \"\" "
buildItem E $rootWn 4.9.3 "S 4 4 {233.402 178.775 288.0 159.0 301.0 226.0 224.0 214.45} 1 \"SET\" \"\" \"\" \"3\" \"0\" \"\" "

# label description (4)
buildItem L $rootWn 4.9.1 "ln 200 22 1 \"ActiveSC\" \"\""
buildItem L $rootWn 4.9.2 "wa 134 144 2 \"SET\" \"\""
buildItem L $rootWn 4.9.3 "wa 315 192 3 \"SET\" \"\""
buildItem L $rootWn 4.9.4 "ln 159 207 4 \"@CSoperational\" \"\""

# #### window .root.10.19   (end)
buildItem DIN $rootWn "4.9.4" "{BPP Resume}"
# #### window CSoperational: .root.10.19.10  -> 0 4.9.4 (begin)
buildW $rootWn "4.9.4" 12 9 11 CSoperational "11"
# node description

# separators
buildItem Z $rootWn 4.9.4.1l "{Z 0.0 0.0 0.908108 2.0}"
buildItem Z $rootWn 4.9.4.1 "{V 0.908108 6}"
buildItem Z $rootWn 4.9.4.1r "{Z 0.908108 0.0 2.0 2.0}"

buildItem F $rootWn 4.9.4.1 "184.0 136.0 169.0 121.0 14 \"inhib\" \"\" CSoperational \"0\" \"1\" \"6\" \"\""
buildItem C $rootWn 4.9.4.2 "93 72 \"5\" \"\" I"
buildItem C $rootWn 4.9.4.3 "272 62 \"8\" \"\" I"
buildItem S $rootWn 4.9.4.9 "93 120 15 \"6\" \"5 7\" N \"\" \"\" \"0\""
buildItem S $rootWn 4.9.4.10 "99 194 15 \"7\" \"6\" N \"\" \"inhib\" \"9\""
buildItem M $rootWn 4.9.4.11 "271 128 47.0001 32.0001 0 \"\" \"8 9\" N \"\" \"@CSOlevel2\" \"11\" "
buildItem C $rootWn 4.9.4.12 "270 206 \"9\" \"\" I"

# edge description
buildItem E $rootWn 4.9.4.5 "I 2 9 {93.0 72.0 93.0 105.0} 1 \"\" \"\" \"\" \"0\" \"0\" \"\" "
buildItem E $rootWn 4.9.4.6 "S 9 10 {111.084 137.262 137.0 162.0 110.474 184.338} 1 \"BPP\" \"\" \"\" \"7\" \"1\" \"\" "
buildItem E $rootWn 4.9.4.7 "S 10 9 {78.264 180.035 50.0 161.0 82.1439 130.351} 1 \"Resume\" \"\" \"\" \"8\" \"0\" \"\" "
buildItem E $rootWn 4.9.4.8 "I 3 11 {272.0 62.0 271.485 95.9999} 1 \"\" \"\" \"\" \"0\" \"0\" \"\" "
buildItem E $rootWn 4.9.4.9 "H 12 11 {270.0 206.0 270.462 169.999} 1 \"inhib\" \"\" \"\" \"10\" \"1\" \"\" "

# label description (11)
buildItem L $rootWn 4.9.4.1 "ln 184.0 22 1 \"CSoperational\" \"\""
buildItem L $rootWn 4.9.4.6 "ld 184.0 249.0 1 \"signal inhib\" \"\""
buildItem L $rootWn 4.9.4.7 "wa 139 145 6 \"#BPP\" \"\""
buildItem L $rootWn 4.9.4.8 "wa 54 185 7 \"Resume\" \"\""
buildItem L $rootWn 4.9.4.9 "st 102 219 10 \"inhib\" \"\""
buildItem L $rootWn 4.9.4.10 "h 293 189 9 \"#inhib\" \"\""
buildItem L $rootWn 4.9.4.11 "ln 271 128 11 \"@CSOlevel2\" \"\""

# #### window .root.10.19.10   (end)
buildItem DIN $rootWn "4.9.4.11" "{APP}"
# #### window CSOlevel2: .root.10.19.10.14  -> 0 4.9.4.11 (begin)
buildW $rootWn "4.9.4.11" 7 5 7 CSOlevel2 "7"
# node description

# separators
buildItem Z $rootWn 4.9.4.11.1l "{Z 0.0 0.0 1.02284 2.0}"
buildItem Z $rootWn 4.9.4.11.1 "{V 1.02284 6}"
buildItem Z $rootWn 4.9.4.11.1r "{Z 1.02284 0.0 2.0 2.0}"

buildItem F $rootWn 4.9.4.11.1 "170.0 130.0 155.0 115.0 14 \"sleep\" \"\" CSOlevel2 \"0\" \"1\" \"5\" \"\""
buildItem C $rootWn 4.9.4.11.2 "94.5 65.5 \"1\" \"\" I"
buildItem C $rootWn 4.9.4.11.3 "260.5 78.5 \"2\" \"\" I"
buildItem C $rootWn 4.9.4.11.4 "259.5 204.5 \"3\" \"\" I"
buildItem S $rootWn 4.9.4.11.5 "93.5 103.5 15 \"4\" \"1 5\" N \"\" \"\" \"0\""
buildItem S $rootWn 4.9.4.11.6 "92.5 182.5 15 \"5\" \"4\" N \"\" \"sleep\" \"4\""
buildItem M $rootWn 4.9.4.11.7 "260.5 134.5 47.0001 27.0 0 \"\" \"2 3\" N \"\" \"@Regulation\" \"7\" "

# edge description
buildItem E $rootWn 4.9.4.11.1 "I 2 5 {94.5 65.5 93.8946 88.5052} 1 \"\" \"\" \"\" \"0\" \"0\" \"\" "
buildItem E $rootWn 4.9.4.11.2 "I 3 7 {260.5 78.5 260.5 107.5} 1 \"\" \"\" \"\" \"0\" \"0\" \"\" "
buildItem E $rootWn 4.9.4.11.3 "H 4 7 {259.5 204.5 259.971 171.499} 1 \"sleep\" \"\" \"\" \"6\" \"1\" \"\" "
buildItem E $rootWn 4.9.4.11.4 "S 5 6 {110.528 121.805 133.5 146.5 103.772 172.603} 1 \"APP\" \"\" \"\" \"2\" \"1\" \"\" "
buildItem E $rootWn 4.9.4.11.5 "S 6 5 {72.3956 167.64 46.5 148.5 82.6654 113.874} 1 \"not APP\" \"\" \"\" \"3\" \"0\" \"\" "

# label description (7)
buildItem L $rootWn 4.9.4.11.1 "ln 170.0 22 1 \"CSOlevel2\" \"\""
buildItem L $rootWn 4.9.4.11.2 "wa 139.5 120.5 4 \"#APP\" \"\""
buildItem L $rootWn 4.9.4.11.3 "wa 50.5 176.5 5 \"not APP\" \"\""
buildItem L $rootWn 4.9.4.11.4 "st 94.5 209.5 6 \"sleep\" \"\""
buildItem L $rootWn 4.9.4.11.5 "ld 170.0 237.0 1 \"signal sleep\" \"\""
buildItem L $rootWn 4.9.4.11.6 "i 288.5 187.5 3 \"#sleep\" \"\""
buildItem L $rootWn 4.9.4.11.7 "ln 259 141 7 \"@Regulation\" \"\""

# #### window .root.10.19.10.14   (end)
buildItem DCO $rootWn "4.9.4.11.7" "{This is a 3-constellation macrostate.
One constellation sustains the signal controlled (that suspends the elsewhere 
defined macro normalGaz)
Another one emits the command to the throttle valve at each occurrence of the
signal RC (Regulation Clock).
A third keeps the value of the speed set point (ref). This variable is not
necessary in this syncCharts. It makes provision for further improvements 
(see improvedCC).
Note that, since the scope of a variable is restricted to a constellation, its
value is broadcast by a signal (REF).

}"
buildItem DFN $rootWn "4.9.4.11.7" "{R(integer,integer):integer}"
buildItem DIN $rootWn "4.9.4.11.7" "{RC}"
buildItem DSE $rootWn "4.9.4.11.7" "{SPD:integer}"
buildItem DOU $rootWn "4.9.4.11.7" "{TVC:integer controlled}"
# #### window Regulation: .root.10.19.10.14.15  -> 0 4.9.4.11.7 (begin)
buildW $rootWn "4.9.4.11.7" 7 4 7 Regulation ""
# node description

# separators
buildItem Z $rootWn 4.9.4.11.7.1ra "{Z 0.994595 0.0 2.0 1.03636}"
buildItem Z $rootWn 4.9.4.11.7.1rb "{Z 0.994595 1.03636 2.0 2.0}"
buildItem Z $rootWn 4.9.4.11.7.1l "{Z 0.0 0.0 0.994595 2.0}"
buildItem Z $rootWn 4.9.4.11.7.1r "{H 1.03636 6}"
buildItem Z $rootWn 4.9.4.11.7.1 "{V 0.994595 7}"

buildItem F $rootWn 4.9.4.11.7.1 "200 140 185 125 14 \"REF:integer\" \"\" Regulation \"0\" \"1\" \"6\" \"{rb 7}\""
buildItem C $rootWn 4.9.4.11.7.2 "98 75 \"1\" \"\" I"
buildItem C $rootWn 4.9.4.11.7.3 "218 82 \"2\" \"\" I"
buildItem C $rootWn 4.9.4.11.7.4 "219 200 \"3\" \"\" I"
buildItem S $rootWn 4.9.4.11.7.5 "98 144 15 \"4\" \"1 4\" N \"\" \"\" \"0\""
buildItem S $rootWn 4.9.4.11.7.6 "301 82 15 \"\" \"2\" N \"\" \"controlled\" \"3\""
buildItem S $rootWn 4.9.4.11.7.7 "297 200 15 \"\" \"3\" N \"\" \"REF(ref)\" \"5\""

# edge description
buildItem E $rootWn 4.9.4.11.7.1 "I 2 5 {98.0 75.0 98.0 129.0} 1 \"\" \"\" \"\" \"0\" \"0\" \"\" "
buildItem E $rootWn 4.9.4.11.7.2 "I 3 6 {218.0 82.0 286.0 82.0} 1 \"\" \"\" \"\" \"0\" \"0\" \"\" "
buildItem E $rootWn 4.9.4.11.7.3 "I 4 7 {219.0 200.0 282.0 200.0} 1 \"\" \"\" \"`ref:=?SPD`\" \"4\" \"0\" \"\" "
buildItem E $rootWn 4.9.4.11.7.4 "S 5 5 {76.6021 156.928 50.0 173.0 76.0 198.0 133.0 198.0 157.0 176.0 111.185 151.151} 1 \"RC\" \"\" \"TVC(R(?SPD,?REF))\" \"2\" \"0\" \"\" "

# label description (7)
buildItem L $rootWn 4.9.4.11.7.1 "ln 200 22 1 \"Regulation\" \"\""
buildItem L $rootWn 4.9.4.11.7.2 "wa 108 216 4 \"RC/TVC(R(?SPD,?REF))\" \"\""
buildItem L $rootWn 4.9.4.11.7.3 "st 297 55 6 \"controlled\" \"\""
buildItem L $rootWn 4.9.4.11.7.4 "i 250 216 3 \"/`ref:=?SPD`\" \"\""
buildItem L $rootWn 4.9.4.11.7.5 "st 300 174 7 \"REF(ref)\" \"\""
buildItem L $rootWn 4.9.4.11.7.6 "ld 200 257 1 \"signal REF:integer\" \"\""
buildItem L $rootWn 4.9.4.11.7.7 "v 292 159 1 \"var ref:integer\" \"\""

# #### window .root.10.19.10.14.15   (end)
initTree

# That's All Folks!
