# /home/andre/NEW_DISTRIB_SC/MYEX/pZeroThru.sc.tcl
# Creation date: Wed Jul  2 07:09:08 MET DST 1997 
# Author: andre 
# Creation directory: /home/andre/NEW_DISTRIB_SC/MYEX 
# Generator: syncCharts v2.051 - 1996-97 
# SyncCharts has been created and developed by 
# Charles ANDRE - I3S Laboratory - University of Nice (F) 
# e-mail:  andre@unice.fr 


global isVALUED
set isVALUED 0
global zoneDesc
global applName
set applName pZeroThru
global _seedName
set rootWn 0
global decls
buildItem DCO "" "" "{pZeroThru:

production-consumption through a buffer whose capacity is 1.
Pure version.

inputs: put, get

outputs: taken, provided

behavior: 

'put' is blocking if the buffer is full. 'taken' is emitted when the buffer
is actually written.
'get' is blocking when the buffer is empty. 'provided' is emitted when the 
buffer is actually read.

The 0-trough hypothesis makes this buffer different from classical ones.

If the buffer is empty, then a simultaneous 'put' and 'get' is possible: 
the item 'goes through' the buffer without a delay; the buffer remains empty;
'taken' and 'provided' are emitted at this instant.

If the buffer is full, then a simultaneous 'put' and 'get' is possible:
the item in the buffer is consumed; the new item is put in the buffer;
'taken' and 'provided' are emitted at this instant.

Compile with the 'check causality' option.
}"
buildItem DIN $rootWn "" "{get put}"
buildItem DOU $rootWn "" "{provided taken}"
# #### window pZeroThru: .root  -> 0  (begin)
buildW $rootWn "" 12 12 14 pZeroThru ""
# node description

# separators
buildItem Z $rootWn 1rl "{Z 0.477534 0.0 1.37923 2.0}"
buildItem Z $rootWn 1r "{V 1.37923 6}"
buildItem Z $rootWn 1rr "{Z 1.37923 0.0 2.0 2.0}"
buildItem Z $rootWn 1l "{Z 0.0 0.0 0.477534 2.0}"
buildItem Z $rootWn 1 "{V 0.477534 7}"

buildItem F $rootWn 1 "251.999 156.0 236.999 141.0 14 \"IN,OUT,E,F\" \"\" pZeroThru \"0\" \"1\" \"14\" \"\""
buildItem C $rootWn 2 "64 69 \"1\" \"\" I"
buildItem S $rootWn 3 "66 124 15 \"2\" \"1 3\" N \"\" \"\" \"0\""
buildItem S $rootWn 4 "68 196 15 \"3\" \"2\" N \"\" \"IN\" \"4\""
buildItem S $rootWn 6 "241 112 15 \"5 7\" \"6 7 12\" N \"\" \"E\" \"9\""
buildItem S $rootWn 7 "242 210 15 \"6 8\" \"5 8\" N \"\" \"F\" \"10\""
buildItem C $rootWn 9 "418 57 \"9\" \"\" I"
buildItem S $rootWn 10 "417 115 15 \"10\" \"9 11\" N \"\" \"\" \"0\""
buildItem S $rootWn 11 "420 200 15 \"11\" \"10\" N \"\" \"OUT\" \"11\""
buildItem C $rootWn 12 "189 73 \"12\" \"\" I"

# edge description
buildItem E $rootWn 1 "I 2 3 {64.0 69.0 65.4549 109.01} 1 \"\" \"\" \"\" \"0\" \"0\" \"\" "
buildItem E $rootWn 2 "S 3 4 {84.2212 141.117 99.0 155.0 100.0 186.0 82.3172 191.526} 1 \"put\" \"\" \"\" \"3\" \"0\" \"\" "
buildItem E $rootWn 3 "W 4 3 {55.238 188.118 34.0 175.0 32.0 152.0 54.421 133.536} 1 \"taken\" \"\" \"\" \"2\" \"1\" \"\" "
buildItem E $rootWn 5 "S 6 7 {262.345 125.015 282.0 137.0 285.0 189.0 255.479 203.417} 2 \"IN\" \"\" \"taken\" \"7\" \"0\" \"\" "
buildItem E $rootWn 6 "S 7 6 {218.486 201.509 206.0 197.0 202.0 150.0 230.257 122.468} 2 \"OUT\" \"\" \"provided\" \"8\" \"0\" \"\" "
buildItem E $rootWn 7 "S 6 6 {254.74 91.1146 266.0 74.0 213.0 65.0 233.323 99.1135} 1 \"IN and OUT\" \"\" \"provided,taken\" \"5\" \"0\" \"\" "
buildItem E $rootWn 8 "S 7 7 {254.862 231.437 269.0 255.0 217.0 255.0 234.715 223.112} 1 \"IN and OUT\" \"\" \"provided,taken\" \"6\" \"0\" \"\" "
buildItem E $rootWn 9 "I 9 10 {418.0 57.0 417.259 100.002} 1 \"\" \"\" \"\" \"0\" \"0\" \"\" "
buildItem E $rootWn 10 "S 10 11 {435.982 131.27 452.0 145.0 456.0 175.0 432.321 191.444} 1 \"get\" \"\" \"\" \"12\" \"0\" \"\" "
buildItem E $rootWn 11 "W 11 10 {406.276 193.945 386.0 185.0 381.0 144.0 405.319 124.41} 1 \"provided\" \"\" \"\" \"13\" \"1\" \"\" "
buildItem E $rootWn 12 "I 12 6 {189.0 73.0 229.0 103.0} 1 \"\" \"\" \"\" \"0\" \"0\" \"\" "

# label description (14)
buildItem L $rootWn 1 "ln 251.999 22 1 \"pZeroThru\" \"\""
buildItem L $rootWn 2 "wa 39 163 3 \"#taken\" \"\""
buildItem L $rootWn 3 "wa 100 167 2 \"put\" \"\""
buildItem L $rootWn 4 "st 68 196 4 \"IN\" \"\""
buildItem L $rootWn 5 "wa 242 54 7 \"IN and OUT/provided,taken\" \"\""
buildItem L $rootWn 6 "wa 246 267 8 \"IN and OUT/provided,taken\" \"\""
buildItem L $rootWn 7 "wa 291 165 5 \"<2>
IN/taken\" \"\""
buildItem L $rootWn 8 "wa 190 168 6 \"<2>
OUT/provided\" \"\""
buildItem L $rootWn 9 "st 241 112 6 \"E\" \"\""
buildItem L $rootWn 10 "st 242 210 7 \"F\" \"\""
buildItem L $rootWn 11 "st 420 200 11 \"OUT\" \"\""
buildItem L $rootWn 12 "wa 456 161 10 \"get\" \"\""
buildItem L $rootWn 13 "wa 389 163 11 \"#provided\" \"\""
buildItem L $rootWn 14 "ld 251.999 289 1 \"signal IN,OUT,E,F\" \"\""

# #### window .root   (end)
initTree

# That's All Folks!
